;; nicola.el version 2.0
;; NICOLA Japanese input liblaries for emacs-lisp
;; Copyright (C) 1995 MINOURA Itsushi <minoura@biol.s.u-tokyo.ac.jp>


;; $B%f!<%6!<@_Dj2DG=JQ?t(B
(defconst nic-interval 100
  "*$B$3$N;~4V(B(ms)$B0JFb$KBG80$5$l$?$b$N$rF1;~BG80$HH=Dj(B")
;(defconst nic-kakutei-interval 80
;  "*$B3NDj$9$k$?$a$K$5$i$KI,MW$J;~4V(B(ms)")
(defconst nic-eisuu-interval 60
  "*$B1Q?t%b!<%I$GF1;~BG80$rG'<1$9$k$?$a$N;~4V(B")

(defconst nic-rshift [f19] "*$B1&%7%U%H%-!<(B")
(defconst nic-lshift [f18] "*$B:8%7%U%H%-!<(B")
(defconst nic-shift-rshift [f17] "*$B%7%U%H1&%7%U%H%-!<(B")
(defconst nic-shift-lshift [f16] "*$B%7%U%H:8%7%U%H%-!<(B")

(defconst nic-use-lshift-as-space nil
  "*t $B$N$H$-!":8%7%U%H$b%9%Z!<%9$H$7$F;H$&!#(B")

(defconst nic-use-space-as-rshift t
  "*non-nil $B$N$H$-%9%Z!<%9$r1&%7%U%H$H$7$F;H$&!#(B")

(defconst nic-bind-bs-to nil
  "*$B$+$J%b!<%I$G$3$N%-!<$K!"%P%C%/%9%Z!<%9$r3d$jEv$F$k!#DL>o!"1&<j>.;X$N(B
$B%[!<%`%]%8%7%g%s$N$R$H$D1&(B")

(defvar second-last-event nil  "last-event $B$N0l$DA0$N(B event $B$r3JG<(B")
(make-variable-buffer-local 'second-last-event)


;; Use char-alist to insert Kana
(defun nic-alist-insert (c list)
  (let ((e (assq c list)))
    (if e
	(insert (cdr e))
      (insert c))))

(defconst nic-hiragana-alist
  '((?1 . "1") (?2 . "2") (?3 . "3") (?4 . "4") (?5 . "5")
    (?6 . "6") (?7 . "7") (?8 . "8") (?9 . "9") (?0 . "0")
    (?- . "-") (?^ . "=") (?\\ . "$B!o(B")
    (?q . "$B!#(B") (?w . "$B$+(B") (?e . "$B$?(B") (?r . "$B$3(B") (?t . "$B$5(B")
    (?y . "$B$i(B") (?u . "$B$A(B") (?i . "$B$/(B") (?o . "$B$D(B") (?p . "$B!$(B")
    (?@ . "$B!"(B") (?\[ . "$B$n(B")
    (?a . "$B$&(B") (?s . "$B$7(B") (?d . "$B$F(B") (?f . "$B$1(B") (?g . "$B$;(B")
    (?h . "$B$O(B") (?j . "$B$H(B") (?k . "$B$-(B") (?l . "$B$$(B") (?\; . "$B$s(B")
    (?z . "$B!%(B") (?x . "$B$R(B") (?c . "$B$9(B") (?v . "$B$U(B") (?b . "$B$X(B")
    (?n . "$B$a(B") (?m . "$B$=(B") (?, . "$B$M(B") (?. . "$B$[(B") (?/ . "$B!&(B")
    ;
    (?! . "!") (?\" . "\"") (?# . "#") (?$ . "$") (?% . "%")
    (?& . "&") (?' . "\'") (?\( . "\(") (?\) . "\)") (?~ . "$B!1(B")
    (?= . "=") (?_ . "_") (?| . "@")
    (?Q . "$B!#(B") (?W . "$B$q(B") (?E . "$B$?(B") (?R . "$B!X(B") (?T . "$B!Y(B")
    (?Y . "$B!Z(B") (?U . "$B![(B") (?I . "$B$/(B") (?O . "$B!9(B") (?P . "$B!$(B")
    (?` . "$B!"(B") (?{ . "$B$n(B")
    (?A . "$B$&(B") (?S . "$B$7(B") (?D . "$B$F(B") (?F . "$B$1(B") (?G . "$B$;(B")
    (?H . "$B$Q(B") (?J . "$B$H(B") (?K . "$B$-(B") (?L . "$B$p(B") (?+ . "$B$s(B")
    (?Z . "$B!%(B") (?X . "$B$T(B") (?C . "$B$9(B") (?V . "$B$W(B") (?B . "$B$Z(B")
    (?N . "$B$a(B") (?M . "$B$=(B") (?< . "$B$M(B") (?> . "$B$](B") (?? . "$B!`(B")
    (?\  . " ")
    "* $B$R$i$,$J(B"))

(defconst nic-rshift-hiragana-alist
  '((?1 . "$B!*(B") (?2 . "$B!E(B") (?3 . "$B!D(B") (?4 . "$B!V(B") (?5 . "$B!W(B")
    (?6 . "$B!N(B") (?7 . "$B!O(B") (?8 . "$B!J(B") (?9 . "$B!K(B") (?0 . "$B!F(B")
    (?- . "$B!G(B") (?^ . "$B!.(B") (?\\ . "$B!@(B") (?_ . "$B!!(B")
    (?q . "$B!,(B") (?w . "$B$,(B") (?e . "$B$@(B") (?r . "$B$4(B") (?t . "$B$6(B")
    (?y . "$B$h(B") (?u . "$B$K(B") (?i . "$B$k(B") (?o . "$B$^(B") (?p . "$B$'(B")
    (?@ . "$B!=(B") (?\[ . "$B!9(B")
    (?a . "$B%t(B") (?s . "$B$8(B") (?d . "$B$G(B") (?f . "$B$2(B") (?g . "$B$<(B")
    (?h . "$B$_(B") (?j . "$B$*(B") (?k . "$B$N(B") (?l . "$B$g(B") (?\; . "$B$C(B")
    (?z . "$B!%(B") (?x . "$B$S(B") (?c . "$B$:(B") (?v . "$B$V(B") (?b . "$B$Y(B")
    (?n . "$B$L(B") (?m . "$B$f(B") (?, . "$B$`(B") (?. . "$B$o(B") (?/ . "$B$)(B")
    (?\  . " ")
     "* $B1&%7%U%H$R$i$,$J(B"))

(defconst nic-lshift-hiragana-alist
  '((?1 . "$B!)(B") (?2 . "$B!?(B") (?3 . "$B!A(B") (?4 . "$B!V(B") (?5 . "$B!W(B")
    (?6 . "$B!N(B") (?7 . "$B!O(B") (?8 . "$B!P(B") (?9 . "$B!Q(B") (?0 . "$B!H(B")
    (?- . "$B!I(B") (?^ . "$B!-(B") (?\\ . "$B!@(B")  (?_ . "$B!!(B")
    (?q . "$B$!(B") (?w . "$B$((B") (?e . "$B$j(B") (?r . "$B$c(B") (?t . "$B$l(B")
    (?y . "$B$Q(B") (?u . "$B$B(B") (?i . "$B$0(B") (?o . "$B$E(B") (?p . "$B$T(B")
    (?@ . "$B!=(B") (?\[ . "$B!9(B")
    (?a . "$B$r(B") (?s . "$B$"(B") (?d . "$B$J(B") (?f . "$B$e(B") (?g . "$B$b(B")
    (?h . "$B$P(B") (?j . "$B$I(B") (?k . "$B$.(B") (?l . "$B$](B") (?\; . "$B$C(B")
    (?z . "$B$%(B") (?x . "$B!<(B") (?c . "$B$m(B") (?v . "$B$d(B") (?b . "$B$#(B")
    (?n . "$B$W(B") (?m . "$B$>(B") (?, . "$B$Z(B") (?. . "$B$\(B") (?/ . "$B!+(B")
    (?\  . " ")
     "* $B:8%7%U%H$R$i$,$J(B"))

(defconst nic-katakana-alist
  '((?1 . "1") (?2 . "2") (?3 . "3") (?4 . "4") (?5 . "5")
    (?6 . "6") (?7 . "7") (?8 . "8") (?9 . "9") (?0 . "0")
    (?- . "$B!](B") (?^ . "$B!a(B") (?\\ . "$B!o(B")
    (?q . "$B!#(B") (?w . "$B%+(B") (?e . "$B%?(B") (?r . "$B%3(B") (?t . "$B%5(B")
    (?y . "$B%i(B") (?u . "$B%A(B") (?i . "$B%/(B") (?o . "$B%D(B") (?p . "$B!$(B")
    (?@ . "$B!"(B") (?\[ . "$B%n(B")
    (?a . "$B%&(B") (?s . "$B%7(B") (?d . "$B%F(B") (?f . "$B%1(B") (?g . "$B%;(B")
    (?h . "$B%O(B") (?j . "$B%H(B") (?k . "$B%-(B") (?l . "$B%$(B") (?\; . "$B%s(B")
    (?z . "$B!%(B") (?x . "$B%R(B") (?c . "$B%9(B") (?v . "$B%U(B") (?b . "$B%X(B")
    (?n . "$B%a(B") (?m . "$B%=(B") (?, . "$B%M(B") (?. . "$B%[(B") (?/ . "$B!&(B")
    ;
    (?! . "!") (?\" . "\"") (?# . "#") (?$ . "$") (?% . "%")
    (?& . "&") (?' . "\'") (?\( . "\(") (?\) . "\)") (?~ . "~")
    (?= . "=") (?_ . "_") (?| . "@")
    (?Q . "$B!#(B") (?W . "$B%q(B") (?E . "$B%u(B") (?R . "$B!X(B") (?T . "$B!Y(B")
    (?Y . "$B!Z(B") (?U . "$B![(B") (?I . "$B%v(B") (?O . "$B%D(B") (?P . "$B!$(B")
    (?` . "$B!"(B") (?{ . "$B!e(B")
    (?A . "$B%&(B") (?S . "$B%7(B") (?D . "$B%F(B") (?F . "$B%1(B") (?G . "$B%1(B")
    (?H . "$B%Q(B") (?J . "$B%H(B") (?K . "$B%-(B") (?L . "$B%p(B") (?+ . "$B%s(B")
    (?Z . "$B!%(B") (?X . "$B%T(B") (?C . "$B%9(B") (?V . "$B%W(B") (?B . "$B%Z(B")
    (?N . "$B%a(B") (?M . "$B%=(B") (?< . "$B%M(B") (?> . "$B%](B") (?? . "$B!`(B")
    (?\  . " ")
    "* $B%+%?%+%J(B"))



(defconst nic-rshift-katakana-alist
  '((?1 . "$B!*(B") (?2 . "$B!E(B") (?3 . "$B!D(B") (?4 . "$B!V(B") (?5 . "$B!W(B")
    (?6 . "$B!N(B") (?7 . "$B!O(B") (?8 . "$B!J(B") (?9 . "$B!K(B") (?0 . "$B!F(B")
    (?- . "$B!G(B") (?^ . "$B!.(B") (?\\ . "$B!@(B") (?_ . "$B!!(B")
    (?q . "$B%!(B") (?w . "$B%,(B") (?e . "$B%@(B") (?r . "$B%4(B") (?t . "$B%6(B")
    (?y . "$B%h(B") (?u . "$B%K(B") (?i . "$B%k(B") (?o . "$B%^(B") (?p . "$B%'(B")
    (?@ . "$B!=(B") (?\[ . "$B!^(B")
    (?a . "$B%t(B") (?s . "$B%8(B") (?d . "$B%G(B") (?f . "$B%2(B") (?g . "$B%<(B")
    (?h . "$B%_(B") (?j . "$B%*(B") (?k . "$B%N(B") (?l . "$B%g(B") (?\; . "$B%C(B")
    (?z . "$B%%(B") (?x . "$B%S(B") (?c . "$B%:(B") (?v . "$B%V(B") (?b . "$B%Y(B")
    (?n . "$B%L(B") (?m . "$B%f(B") (?, . "$B%`(B") (?. . "$B%o(B") (?/ . "$B%)(B")
    (?\  . " ")
  "* $B1&%7%U%H%+%?%+%J(B"))

(defconst nic-lshift-katakana-alist
  '((?1 . "$B!)(B") (?2 . "$B!?(B") (?3 . "$B!A(B") (?4 . "$B!V(B") (?5 . "$B!W(B")
    (?6 . "$B!N(B") (?7 . "$B!O(B") (?8 . "$B!P(B") (?9 . "$B!Q(B") (?0 . "$B!H(B")
    (?- . "$B!I(B") (?^ . "$B!-(B") (?\\ . "$B!@(B")  (?_ . "$B!!(B")
    (?q . "$B%!(B") (?w . "$B%((B") (?e . "$B%j(B") (?r . "$B%c(B") (?t . "$B%l(B")
    (?y . "$B%Q(B") (?u . "$B%B(B") (?i . "$B%0(B") (?o . "$B%E(B") (?p . "$B%T(B")
    (?@ . "$B!=(B") (?\[ . "$B!^(B")
    (?a . "$B%r(B") (?s . "$B%"(B") (?d . "$B%J(B") (?f . "$B%e(B") (?g . "$B%b(B")
    (?h . "$B%P(B") (?j . "$B%I(B") (?k . "$B%.(B") (?l . "$B%](B") (?\; . "$B%C(B")
    (?z . "$B%%(B") (?x . "$B!<(B") (?c . "$B%m(B") (?v . "$B%d(B") (?b . "$B%#(B")
    (?n . "$B%W(B") (?m . "$B%>(B") (?, . "$B%Z(B") (?. . "$B%\(B") (?/ . "$B%)(B")
    (?\  . " ")
    "* $B:8%7%U%H%+%?%+%J(B"))

(defconst nic-zenkaku-alist
  '((?1 . "$B#1(B") (?2 . "$B#2(B") (?3 . "$B#3(B") (?4 . "$B#4(B") (?5 . "$B#5(B")
    (?6 . "$B#6(B") (?7 . "$B#7(B") (?8 . "$B#8(B") (?9 . "$B#9(B") (?0 . "$B#0(B")
    (?- . "$B!](B") (?^ . "$B!0(B") (?\\ . "$B!o(B")
    (?q . "$B#q(B") (?w . "$B#w(B") (?e . "$B#e(B") (?r . "$B#r(B") (?t . "$B#t(B")
    (?y . "$B#y(B") (?u . "$B#u(B") (?i . "$B#i(B") (?o . "$B#o(B") (?p . "$B#p(B")
    (?@ . "$B!w(B") (?\[ . "$B!N(B")
    (?a . "$B#a(B") (?s . "$B#s(B") (?d . "$B#d(B") (?f . "$B#f(B") (?g . "$B#g(B")
    (?h . "$B#h(B") (?j . "$B#j(B") (?k . "$B#k(B") (?l . "$B#l(B") (?\; . "$B!((B")
    (?\] . "$B!O(B")
    (?z . "$B#z(B") (?x . "$B#x(B") (?c . "$B#c(B") (?v . "$B#v(B") (?b . "$B#b(B")
    (?n . "$B#n(B") (?m . "$B#m(B") (?, . "$B!$(B") (?. . "$B!%(B") (?/ . "$B!?(B")
    (?: . "$B!'(B") (?  . "$B!!(B")
    ;
    (?! . "$B!*(B") (?\" . "$B!I(B") (?# . "$B!t(B") (?$ . "$B!p(B") (?% . "$B!s(B")
    (?& . "$B!u(B") (?' . "$B!G(B") (?\( . "$B!J(B") (?\) . "$B!K(B") (?~ . "$B!1(B")
    (?= . "$B!a(B") (?_ . "$B!2(B") (?| . "$B!w(B")
    (?Q . "$B#Q(B") (?W . "$B#W(B") (?E . "$B#E(B") (?R . "$B#R(B") (?T . "$B#T(B")
    (?Y . "$B#Y(B") (?U . "$B#U(B") (?I . "$B#I(B") (?O . "$B#O(B") (?P . "$B#P(B")
    (?` . "$B!.(B") (?{ . "$B!P(B")
    (?A . "$B#A(B") (?S . "$B#S(B") (?D . "$B#D(B") (?F . "$B#F(B") (?G . "$B#G(B")
    (?H . "$B#H(B") (?J . "$B#J(B") (?K . "$B#K(B") (?L . "$B#L(B") (?+ . "$B!\(B")
    (?} . "$B!Q(B")
    (?Z . "$B#Z(B") (?X . "$B#X(B") (?C . "$B#C(B") (?V . "$B#V(B") (?B . "$B#B(B")
    (?N . "$B#N(B") (?M . "$B#M(B") (?< . "$B!c(B") (?> . "$B!d(B") (?? . "$B!)(B")
    (?\  . " ")
    "* $BA43Q1Q?t(B"))

(defvar nic-henkan-alist
  '(( "$B$!(B" . "$B$!(B") ( "$B$"(B" . "$B$"(B") ( "$B$#(B" . "$B$#(B") ( "$B$$(B" . "$B$$(B")
    ( "$B$%(B" . "$B$%(B") ( "$B$&(B" . "$B$&(B") ( "$B$'(B" . "$B$'(B") ( "$B$((B" . "$B$((B")
    ( "$B$)(B" . "$B$)(B") ( "$B$*(B" . "$B$*(B") ( "$B$+(B" . "$B$+(B") ( "$B$,(B" . "$B$,(B")
    ( "$B$-(B" . "$B$-(B") ( "$B$.(B" . "$B$.(B") ( "$B$/(B" . "$B$/(B") ( "$B$0(B" . "$B$0(B")
    ( "$B$1(B" . "$B$1(B") ( "$B$2(B" . "$B$2(B") ( "$B$3(B" . "$B$3(B") ( "$B$4(B" . "$B$4(B")
    ( "$B$5(B" . "$B$5(B") ( "$B$6(B" . "$B$6(B") ( "$B$7(B" . "$B$7(B") ( "$B$8(B" . "$B$8(B")
    ( "$B$9(B" . "$B$9(B") ( "$B$:(B" . "$B$:(B") ( "$B$;(B" . "$B$;(B") ( "$B$<(B" . "$B$<(B")
    ( "$B$=(B" . "$B$=(B") ( "$B$>(B" . "$B$>(B") ( "$B$?(B" . "$B$?(B") ( "$B$@(B" . "$B$@(B")
    ( "$B$A(B" . "$B$A(B") ( "$B$B(B" . "$B$B(B") ( "$B$C(B" . "$B$C(B") ( "$B$D(B" . "$B$D(B")
    ( "$B$E(B" . "$B$E(B") ( "$B$F(B" . "$B$F(B") ( "$B$G(B" . "$B$G(B") ( "$B$H(B" . "$B$H(B")
    ( "$B$I(B" . "$B$I(B") ( "$B$J(B" . "$B$J(B") ( "$B$K(B" . "$B$K(B") ( "$B$L(B" . "$B$L(B")
    ( "$B$M(B" . "$B$M(B") ( "$B$N(B" . "$B$N(B") ( "$B$O(B" . "$B$O(B") ( "$B$P(B" . "$B$P(B")
    ( "$B$Q(B" . "$B$Q(B") ( "$B$R(B" . "$B$R(B") ( "$B$S(B" . "$B$S(B") ( "$B$T(B" . "$B$T(B")
    ( "$B$U(B" . "$B$U(B") ( "$B$V(B" . "$B$V(B") ( "$B$W(B" . "$B$W(B") ( "$B$X(B" . "$B$X(B")
    ( "$B$Y(B" . "$B$Y(B") ( "$B$Z(B" . "$B$Z(B") ( "$B$[(B" . "$B$[(B") ( "$B$\(B" . "$B$\(B")
    ( "$B$](B" . "$B$](B") ( "$B$^(B" . "$B$^(B") ( "$B$_(B" . "$B$_(B") ( "$B$`(B" . "$B$`(B")
    ( "$B$a(B" . "$B$a(B") ( "$B$b(B" . "$B$b(B") ( "$B$c(B" . "$B$c(B") ( "$B$d(B" . "$B$d(B")
    ( "$B$e(B" . "$B$e(B") ( "$B$f(B" . "$B$f(B") ( "$B$g(B" . "$B$g(B") ( "$B$h(B" . "$B$h(B")
    ( "$B$i(B" . "$B$i(B") ( "$B$j(B" . "$B$j(B") ( "$B$k(B" . "$B$k(B") ( "$B$l(B" . "$B$l(B")
    ( "$B$m(B" . "$B$m(B") ( "$B$n(B" . "$B$n(B") ( "$B$o(B" . "$B$o(B") ( "$B$p(B" . "$B$p(B")
    ( "$B$q(B" . "$B$q(B") ( "$B$r(B" . "$B$r(B") ( "$B$s(B" . "$B$s(B") ( "$B!<(B" . "$B!<(B")
    ( "$B#1(B" . "$B#1(B") ( "$B#2(B" . "$B#2(B") ( "$B#3(B" . "$B#3(B") ( "$B#4(B" . "$B#4(B")
    ( "$B#5(B" . "$B#5(B") ( "$B#6(B" . "$B#6(B") ( "$B#7(B" . "$B#7(B") ( "$B#8(B" . "$B#8(B")
    ( "$B#9(B" . "$B#9(B") ( "$B#0(B" . "$B#0(B") ( "$B%t(B" . "$B%t(B") ))

;; $B0J2<$O8E$$$b$N$H$N8_49@-$N$?$a!#(B

;; NICOLA $B$H$OD>@\4X78$J$$$1$I(B
(defconst nic-hiragana-cursor-color "gray30" "*$B$R$i$,$J$N;~$N%+!<%=%k?'(B")
(defconst nic-katakana-cursor-color "forestgreen" "*$B%+%?%+%J$N;~$N%+!<%=%k?'(B")
(defconst nic-hankaku-cursor-color "black" "*$BH>3Q$N;~$N%+!<%=%k?'(B")
(defconst nic-zenkaku-cursor-color "blue" "*$BA43Q$N;~$N%+!<%=%k?'(B")

;; version 1.5
;(defconst nic-use-two-shift-key t "*non-nil $B$J$i$P(B2$B$D$N%7%U%H%-!<$r;H$&!#(B")
; obsolete b-algorithm
(defconst nic-single-delay 0 "*1$B2s$KBT$D;~4V(B (ms)")
(defconst nic-interval-limit 200 "*$B:GBg$3$N2s?t$@$1%-!<F~NO$rBT$D!#(B")


; obsolete b-algorithm
;(defvar last-interval nil  "$B$R$H$DA0$N(B interval $B$r3JG<(B")
;(make-variable-buffer-local 'last-interval)

(defconst nic-record-file "~/.nic-record")
(defvar nic-strokes 0)
(defvar nic-used-interval-ct 0)
(defvar nic-unused-interval-ct 0)
(defvar nic-used-max 0)
(defvar nic-used-min 9999)
(defvar nic-unused-max 0)
(defvar nic-unused-min 9999)


;(defun nic-interval-of-keys (&optional arg)
;  ;; $B%-!<F~NO$,$J$1$l$P(B nil $B$rJV$9!"$"$l$P(B interval $B$rJV$9!#(B
;  ;; interval $B$O(B 0 $B$+$i(B nic-interval-limit $B$^$G$N(B integer.
;  ;; for Mule
;  (let ((interval)
;	(count (if arg
;		   arg
;		 0)))
;    (if (sit-for 0 nic-single-interval nil)
;	;; t : no key in
;	(progn
;	  (if (>= count nic-interval-limit)
;	      (setq interval nil)
;	    (setq count (1+ count))
;	    (setq interval (nic-interval-of-keys count))  ; recursive
;	    ))
;      ;; nil
;      (setq interval count))))

(defun nic-interval-of-keys (&optional count-max)
  ;; $B%-!<F~NO$,$J$1$l$P(B nil $B$rJV$9!"$"$l$P(B interval $B$rJV$9!#(B
  ;; count-max $B$,$"$k$H$-$K$O!"(Bnic-interval-limit $B$NBe$o$j$K(B count-max
  ;; $B$r;H$&!#(B
  ;; interval $B$O(B 0 $B$+$i(B nic-interval-limit $B$^$G$N(B integer.
  (let ((count 0)
	(continue t)
	(limit (or count-max nic-interval-limit)))
    (while continue
      (if (sit-for 0 nic-single-delay nil)
	  ;; t : no key in
	  (if (> count limit)
	      (setq continue nil
		    count nil)
	    (setq count (1+ count)))
	;; key in
	(setq continue nil)))
    count))



;(defvar nic-char-type-vector
;  [0 0 0 0 0 0 0 0            ;nil  nil  nil  nil  nil  nil  nil  nil
;   5 0 0 0 0 0 0 0            ;nil  nil  nil  nil  nil  nil  nil  nil
;   0 0 0 0 0 0 0 0            ;nil  nil  nil  nil  nil  nil  nil  nil
;   0 0 0 0 0 0 0 0            ;nil  nil  nil  nil  nil  nil  nil  nil
;   0 0 0 0 0 0 0 0            ;"$B!!(B"  "$B!*(B" "$B!I(B" "$B!t(B" "$B!p(B" "$B!s(B" "$B!u(B" "$B!G(B
;   0 0 0 0 0 0 0 0            ;"$B!J(B" "$B!K(B" "$B!v(B" "$B!\(B" "$B!$(B" "$B!](B" "$B!%(B" "$B!?(B"
;   0 0 0 0 0 0 0 0            ;"$B#0(B" "$B#1(B" "$B#2(B" "$B#3(B" "$B#4(B" "$B#5(B" "$B#6(B" "$B#7(B"
;   0 0 0 0 0 0 0 0            ;"$B#8(B" "$B#9(B" "$B!'(B" "$B!((B" "$B!c(B" "$B!a(B" "$B!d(B" "$B!)(B"
;   0 4 4 4 4 4 4 4            ;"$B!w(B" "$B#A(B" "$B#B(B" "$B#C(B" "$B#D(B" "$B#E(B" "$B#F(B" "$B#G(B"
;   4 4 4 4 0 4 4 4            ;"$B#H(B" "$B#I(B" "$B#J(B" "$B#K(B" "$B#L(B" "$B#M(B" "$B#N(B" "$B#O(B"
;   4 0 4 4 4 4 4 4            ;"$B#P(B" "$B#Q(B" "$B#R(B" "$B#S(B" "$B#T(B" "$B#U(B" "$B#V(B" "$B#W(B"
;   0 4 4 0 0 0 0 0            ;"$B#X(B" "$B#Y(B" "$B#Z(B" "$B!N(B" "$B!@(B" "$B!O(B" "$B!0(B" "$B!2(B"
;   0 3 1 1 1 3 1 1            ;"$B!F(B" "$B#a(B" "$B#b(B" "$B#c(B" "$B#d(B" "$B#e(B" "$B#f(B" "$B#g(B"
;   1 3 1 1 0 1 2 3            ;"$B#h(B" "$B#i(B" "$B#j(B" "$B#k(B" "$B#l(B" "$B#m(B" "$B#n(B" "$B#o(B"
;   1 0 1 1 1 3 1 1            ;"$B#p(B" "$B#q(B" "$B#r(B" "$B#s(B" "$B#t(B" "$B#u(B" "$B#v(B" "$B#w(B"
;   2 1 1 0 0 0 0 5]           ; "$B#x(B" "$B#y(B" "$B#z(B" "$B!P(B" "$B!C(B" "$B!Q(B" "$B!A(B" nil]
;  "*NICOLA $BF~NO$G%-!<$N<oJL$r<($9%Y%/%?!<!#(B
;$B3FMWAG$N?t;z$N0UL#$O2<5-$NDL$j!#(B

;0 $B;HMQ$7$F$$$J$$!#(B
;1 $BJ8;z(B
;2 $B>e5-(B 1 $B0J30$N;R2;(B (n, x)
;3 $BJl2;(B
;4 skk-mode $B$G!"(Bskk-set-henkan-point $B$K3d$jIU$1$i$l$F$$$kJ8;z!#(B
;5 $B%W%l%U%#%C%/%9$r>C5n$9$k(B" )


(defun nic-add-interval (interval &optional used)
   (if interval
       (if used
	   (progn
	     (if (> interval nic-used-max)
		 (setq nic-used-max interval))
	     (if (< interval nic-used-min)
		 (setq nic-used-min interval))
	     (setq nic-used-interval-ct (1+ nic-used-interval-ct)) )
	 (if (> interval nic-unused-max)
	     (setq nic-unused-max interval))
	 (if (< interval nic-unused-min)
	     (setq nic-unused-min interval))
	 (setq nic-unused-interval-ct (1+ nic-unused-interval-ct)) ))
   (setq nic-strokes (1+ nic-strokes)))
    

(provide 'nicola)
