;; skk-nicola.el
;; version 0.35 (Dec 25, 1997)
;; version 0.3 (Dec 2, 1997)
;; version 0.25 (Aug 29, 1996)
;; This is for SKK version 9.2
;; Copyright (C)1996 Itsushi Minoura <minoura@biol.s.u-tokyo.ac.jp>
;; SKK  NICOLA ϥ󥿡ե󶡤롣


;;; Code:

(require 'nicola)
(require 'skk)

;; NICOLA ⡼ɤɽ
(setq skk-mode-string "N-SKK:")
(setq skk-hirakana-mode-string "N-")
(setq skk-katakana-mode-string "N-")
;(setq skk-zenei-mode-string "--")

(defvar skk-nic-use-kana-for-henkan t
  "*non-nil ΤȤϡ[fj] ǼưŪˤʥ⡼ɤˤʤ롣")

(defconst skk-nic-kana-base (string-to-char "")
  "ʤ޻Ѵ뤿˻Ȥ")

(setq skk-previous-candidate-char ?\C-p)

;; skk.el ƤΤ   x ʤɤˤʤäƤơȤʤ
(setq skk-kana-rom-vector
  ["x" "a" "x" "i" "x" "u" "x" "e" "x" "o" "k" "g" "k" "g" "k" "g"
   "k" "g" "k" "g" "s" "z" "s" "j" "s" "z" "s" "z" "s" "z" "t" "d"
   "t" "d" "t" "t" "d" "t" "d" "t" "d" "n" "n" "n" "n" "n" "h" "b"
   "p" "h" "b" "p" "h" "b" "p" "h" "b" "p" "h" "b" "p" "m" "m" "m"
   "m" "m" "y" "y" "y" "y" "y" "y" "r" "r" "r" "r" "r" "w" "w" "w"
   "w" "w" "n"])

;; iueo -> w
;; (and skk-nic-incompat-jisyo skk-henkan-okuri-strictly)  t ΤȤ
;; Τͭ
;(setq skk-kana-rom-vector2
;  ["x" "a" "x" "w" "x" "w" "x" "w" "x" "w" "k" "g" "k" "g" "k" "g"
;   "k" "g" "k" "g" "s" "z" "s" "j" "s" "z" "s" "z" "s" "z" "t" "d"
;   "t" "d" "t" "t" "d" "t" "d" "t" "d" "n" "n" "n" "n" "n" "h" "b"
;   "p" "h" "b" "p" "h" "b" "p" "h" "b" "p" "h" "b" "p" "m" "m" "m"
;   "m" "m" "y" "y" "y" "y" "y" "y" "r" "r" "r" "r" "r" "w" "w" "w"
;   "w" "w" "n"])

(defvar skk-nic-lshift-org-command nil)
(make-variable-buffer-local 'skk-nic-lshift-org-command)

(defvar nic-dynamic-interval nic-interval)
(make-variable-buffer-local 'nic-dynamic-interval)

(load skk-init-file t)

(defconst nic-lshift-char (if (stringp nic-lshift)  ;; sequencep is right??
			      (string-to-char nic-lshift)
			    nic-lshift)
  "եȤɽ")
(defconst nic-rshift-char (if (stringp nic-rshift)
			      (string-to-char nic-rshift)
			    nic-rshift)
  "եȤɽ")


(defun skk-define-map (map &optional minibuff)
  ;; ޥå MAP ѤNICOLA SKK ΥХɤΥåȥåפԤ
  ;; ץʥ MINIBUFF  non-nil ǤСߥ˥ХåեѤ
  ;; åȥåפԤ
  (let ((i 32)) ;; 32 = ?\ 
    (while (<= i 126)
      (define-key map (char-to-string i) 'skk-nic-insert)
      (setq i (1+ i))))
  (define-key map "\C-g" 'skk-keyboard-quit)
  (define-key map
    (if minibuff (default-value 'skk-kakutei-key) skk-kakutei-key)
    'skk-kakutei )
  (define-key map "\C-m" 'skk-newline)
  (define-key map "\C-p" 'skk-previous-candidate)
  (define-key map "\C-n" 'skk-next-candidate)
  (define-key map "\t" 'skk-try-completion)
  (define-key map "\C-n" 'skk-next-candidate)
  (define-key map "\M-k" 'skk-toggle-kana)
  (define-key map "$" 'skk-display-code-for-char-at-point)
  (define-key map "\]" 'skk-today)
  (define-key map "Z" 'skk-nic-select-zenkaku)
  (define-key map "?" 'skk-abbrev-input)
  (define-key map "<" 'skk-nic-set-suffix)
  (define-key map "\\" 'skk-input-by-code-or-menu)
  (define-key map "\177" 'skk-delete-backward-char)
  (if nic-bind-bs-to
      (define-key map nic-bind-bs-to 'skk-delete-backward-char))
  (let ((local-map (current-local-map)))
    (unwind-protect
	(progn
	  (use-local-map map)
	  (setq skk-nic-lshift-org-command (key-binding nic-lshift))
	  (use-local-map local-map))))
  (define-key map nic-rshift 'skk-nic-insert)
  (define-key map nic-lshift 'skk-nic-insert) )



(defun skk-setup-abbrev-map ()
  ;; abbrev ⡼ɤΥޥåפΥåȥåפԤʤ
  (setq skk-abbrev-map (skk-convert-to-vector skk-emacs-local-map))
  (define-key skk-abbrev-map "\C-g" 'skk-keyboard-quit)
  (define-key skk-abbrev-map "\ "   'skk-nic-insert)
  (define-key skk-abbrev-map "\C-m" 'skk-newline)
  (define-key skk-abbrev-map "\t" 'skk-try-completion)
  (define-key skk-abbrev-map "\C-p" 'skk-previous-candidate)
  (define-key skk-abbrev-map "\C-n" 'skk-next-candidate)
  (define-key skk-abbrev-map "\C-q" 'skk-zenkaku-henkan)
  (define-key skk-abbrev-map skk-kakutei-key 'skk-nic-select-hiragana)
  (define-key skk-abbrev-map "\177" 'skk-delete-backward-char)
  (if nic-bind-bs-to
      (define-key skk-abbrev-map nic-bind-bs-to 'skk-delete-backward-char))
  (define-key skk-abbrev-map nic-rshift 'skk-nic-insert)
  (define-key skk-abbrev-map nic-lshift 'skk-nic-insert) )



(defun skk-nic-select-hiragana ()
  ;; Ҥ餬
  (interactive)
  (if (not skk-mode)
      (skk-mode 1))
  (setq skk-j-mode t
	skk-katakana nil
	skk-zenkaku nil)
  (use-local-map skk-map)
  (setq nic-dynamic-interval nic-interval)
  (skk-change-mode-line skk-hirakana-mode-string)
  (cond ((and (eq window-system 'x) (x-display-color-p))
	 (set-cursor-color nic-hiragana-cursor-color))))


(defun skk-nic-select-hankaku ()
  (interactive)
  (if (not skk-mode)
      (skk-mode 1))
  (setq skk-j-mode nil
	skk-katakana nil
	skk-zenkaku nil)
  (use-local-map (if (skk-in-minibuffer-p)
		     minibuffer-local-map
		   skk-emacs-local-map))
  (setq nic-dynamic-interval nic-eisuu-interval)
  (skk-change-mode-line skk-mode-string)
  (cond ((and (eq window-system 'x) (x-display-color-p))
	 (set-cursor-color nic-hankaku-cursor-color))))

(defun skk-nic-select-zenkaku ()
  (interactive)
  (if (not skk-mode)
      (skk-mode 1))
  (setq skk-j-mode nil
	skk-katakana nil
	skk-zenkaku t)
  (use-local-map skk-zenkaku-map)
  (setq nic-dynamic-interval nic-eisuu-interval)
  (skk-change-mode-line skk-zenei-mode-string)
  (cond ((and (eq window-system 'x) (x-display-color-p))
	 (set-cursor-color nic-zenkaku-cursor-color))))


(defun skk-nic-select-katakana ()
  (interactive)
  (if (not skk-mode)
      (skk-mode 1))
  (setq skk-j-mode t
	skk-katakana t
	skk-zenkaku nil)
  (use-local-map skk-map)
  (setq nic-dynamic-interval nic-interval)
  (skk-change-mode-line skk-katakana-mode-string)
  (cond ((and (eq window-system 'x) (x-display-color-p))
	 (set-cursor-color nic-katakana-cursor-color))))


(defun skk-nic-insert (arg)
  ;; ƱǸǧơNICOLA Ϥ򤹤롣
  (interactive "p")
  (if second-last-event
      ;; ΥϤȤ
      (progn
	(skk-nic-insert-command last-command-event second-last-event)
	  (if (not skk-henkan-on) (skk-do-auto-fill))
	  (setq second-last-event nil))
    (cond ((or (equal last-command-event nic-rshift-char)
	       (and nic-use-space-as-rshift (equal last-command-event ?\ )))
	   (if (sit-for 0 nic-dynamic-interval nil) 
	       (skk-nic-space-function)  ;; long interval / Ѵڡ
	     (setq second-last-event last-command-event)))
	  ((equal last-command-event nic-lshift-char)
	   (if (sit-for 0 nic-dynamic-interval nil)
	       ;; long interval
	       (skk-nic-lshift-function)
	     ;; short interval
	     (setq second-last-event last-command-event)))
	  (t
	   ;; եȤǤϤʤȤ
	   (if (sit-for 0 nic-dynamic-interval nil)
	       ;; long interval
	       (progn
		 (skk-nic-insert-char last-command-event)
		 (if (not skk-henkan-on) (skk-do-auto-fill))
		 (setq second-last-event nil))
	     ;; short interval
	     (setq second-last-event last-command-event))))))


(defun skk-nic-insert-command (last-event secd-last-event)
  (cond ((or (equal secd-last-event nic-rshift-char)
	     (and nic-use-space-as-rshift (equal secd-last-event ?\ )))
	 (cond ((or (equal last-event nic-rshift-char) ;; []
		    (and nic-use-space-as-rshift (equal last-event ?\ )))
		;; (if skk-henkan-on  ɬס
		(skk-insert-str " ")
		(skk-insert-str " ")
		(and auto-fill-function (funcall auto-fill-function)))
	       ((equal last-event nic-lshift-char) ;; []
		(skk-nic-toggle-mode))
	       (t		                   ;; [ ʸ]
		(skk-nic-rshifted-insert-char last-event)))
	 (setq secd-last-event nil))
	((equal secd-last-event nic-lshift-char)
	 (cond ((equal last-event nic-lshift-char) ;;[]
		(if (skk-in-minibuffer-p)
		    (exit-minibuffer)
		  (progn
		    (skk-nic-lshift-function)
		    (skk-nic-lshift-function))))
	       ((or (equal last-event nic-rshift-char) ;; []
		    (and nic-use-space-as-rshift (equal last-event ?\ )))
		(skk-nic-toggle-mode))
	       (t                                  ;; [ ʸ]
		(skk-nic-lshifted-insert-char last-event)))
	 (setq secd-last-event nil))
	(t
	 (cond ((or (equal last-event nic-rshift-char) ;;  [ʸ ]
		    (and nic-use-space-as-rshift (equal last-event ?\ )))
		(skk-nic-rshifted-insert-char secd-last-event))
	       ((equal last-event nic-lshift-char) ;; [ʸ ]
		(skk-nic-lshifted-insert-char secd-last-event))
	       ((or      ;; [fj]
		 (and (equal last-event ?j) (equal secd-last-event ?f))
		 (and (equal last-event ?f) (equal secd-last-event ?j)))
		(skk-set-henkan-point))
	       ((or      ;; [gh] sufix 
		 (and (equal last-event ?g) (equal secd-last-event ?h))
		 (and (equal last-event ?h) (equal secd-last-event ?g)))
		(skk-nic-set-suffix))
	       ((or      ;; [dk]
		 (and (equal last-event ?d) (equal secd-last-event ?k))
		 (and (equal last-event ?k) (equal secd-last-event ?d)))
		(skk-toggle-kana nil))
	       (t                                  ;; [ʸ ʸ]
		(skk-nic-insert-char secd-last-event)
		(skk-nic-insert-char last-event)))
	 (setq secd-last-event nil))))


(defun skk-nic-insert-char (c)
  ;; եȤʤʸ
  (if (and skk-henkan-active skk-kakutei-early) (skk-kakutei))
  (if skk-j-mode
      (nic-alist-insert c (if skk-katakana
			      nic-katakana-alist
			    nic-hiragana-alist))
    (skk-insert-str last-command-event))
  (if skk-okurigana
      (skk-set-okurigana)) )
  

(defun skk-nic-rshifted-insert-char (c)
  ;; եʸ
  (if (and skk-henkan-active skk-kakutei-early) (skk-kakutei))
  (if skk-j-mode
      (nic-alist-insert c (if skk-katakana
			      nic-rshift-katakana-alist
			    nic-rshift-hiragana-alist))
    (skk-insert-str last-command-event))
  (if skk-okurigana
      (skk-set-okurigana)) )
  

(defun skk-nic-lshifted-insert-char (c)
  ;; եʸ
  (if (and skk-henkan-active skk-kakutei-early) (skk-kakutei))
  (if skk-j-mode
      (nic-alist-insert c (if skk-katakana
			      nic-lshift-katakana-alist
			    nic-lshift-hiragana-alist))
    (skk-insert-str last-command-event))
  (if skk-okurigana
      (skk-set-okurigana)) )
    

(defun skk-nic-toggle-mode ()
  ;; Ҥ餬ʥ⡼ɤΤȤˤȾѥ⡼ɤءʳΤȤˤϥʥ⡼ɤ
  (setq last-command-event nil)
  (if (and skk-j-mode (not skk-katakana))
      (skk-nic-select-hankaku)
    (skk-nic-select-hiragana)))


(defun skk-nic-space-function (&optional arg)
  (interactive "p")
  (if (and arg second-last-event)  ; flush buffer
	(skk-nic-insert-char second-last-event)
	(setq second-last-event nil) ) 
  (if (or skk-henkan-on skk-henkan-active)
      (skk-start-henkan ?\ )
    (skk-insert-str " ")
    (and auto-fill-function (funcall auto-fill-function))))

(defun skk-nic-lshift-function ()
  ;; lshift 줿եȤǤϤʤΤǡǽ¹Ԥ롣
  ;; skk-nic-insert ƤӽФȡ̵¥롼פˤʤΤǡ
  ;; 򤱤롣
  (if nic-use-lshift-as-space
      (skk-nic-space-function)
    (if (equal skk-nic-lshift-org-command 'skk-nic-insert)
	(skk-nic-insert-char nic-lshift)
      (command-execute (or skk-nic-lshift-org-command
			   (function undefined))))) )



(defun skk-set-okurigana ()
  (let (w-head)
    (move-marker skk-henkan-end-point skk-okurigana-start-point)
    (save-excursion
      ;; just in case
      (goto-char skk-okurigana-start-point)
      (or (looking-at "*") (insert "*")))
    (setq w-head (buffer-substring skk-henkan-start-point
				   skk-henkan-end-point)
	  ;; nicola
          skk-henkan-okurigana (buffer-substring
                                (1+ skk-okurigana-start-point)
                                (point) )
	  skk-okuri-char (aref
			  skk-kana-rom-vector
			  ; wiueo
			  ;(if skk-nic-incompat-jisyo
			  ;    skk-kana-rom-vector2
			  ;  skk-kana-rom-vector)
			  (- (string-to-char (substring
					      skk-henkan-okurigana
					      0
					      skk-kanji-len))
			     skk-nic-kana-base))
	  skk-henkan-key2 (concat w-head "*" skk-henkan-okurigana)
	  skk-henkan-key (concat w-head skk-okuri-char) )
;    (setq skk-prefix ""
;	  skk-okuri-char "")
    (delete-region
     skk-okurigana-start-point (1+ skk-okurigana-start-point))
    (skk-henkan)
    (setq skk-okurigana nil)))

(defun skk-next-candidate (&optional arg)
;; ѴǤСθɽ롣
;; completion λˤϼθɽ򤹤롣 
;; ʳΤȤ skk-emulate-original-keymap ¹ԡ
  (interactive "p")
  (if (eq last-command 'skk-completion)
      (progn
        (setq this-command 'skk-completion)
	(skk-completion nil))
    (if skk-henkan-active
	(skk-start-henkan ?\ )
      (skk-emulate-original-map arg))))


(defun skk-nic-set-suffix ()
  (interactive)
  (cond (skk-henkan-active   ;; ν
	 (skk-kakutei)
	 (skk-set-henkan-point-subr)	
	 (insert ?>))
	((and skk-henkan-on (not skk-henkan-active))  ;; Ƭν
	 (insert ?>)
	 (set-marker skk-henkan-end-point (point))
	 (setq skk-henkan-count 0
	       skk-henkan-key (buffer-substring
			       skk-henkan-start-point (point) )
	       skk-search-key skk-henkan-key )
	 (skk-henkan))
	(t
	 (skk-abbrev-input)) ))

(defun skk-set-henkan-point ()
  ;; Ѵޤ꤬ʤλ򤹤롣
  (cond ((and skk-henkan-on skk-okurigana)
	 (setq second-last-event nil)
	 (error "Ǥ꤬ʤꤵƤޤ"))
	((and skk-henkan-on (= (point) skk-henkan-start-point))
	 (skk-kakutei)
	 (setq second-last-event nil)
	 (error "Ѵоݤޤ") )
	((and (not skk-henkan-active) skk-henkan-on)
	 (move-marker skk-okurigana-start-point (point))
	 (insert "*")
	 (move-marker skk-henkan-end-point (point))
	 (set-marker skk-kana-start-point (point))
	 (setq skk-okurigana t))
	(t
	 (if skk-henkan-active
	     (skk-kakutei))
	 (skk-set-henkan-point-subr)) ))


(defun skk-start-henkan (arg)
  (interactive "p")
  (if skk-henkan-on
      (progn
	(or skk-j-mode
	    ; NICOLA
	    (and (skk-nic-select-hiragana)
		 (setq skk-j-mode t)))
	(if skk-henkan-active (skk-henkan)
	  (or (string= skk-prefix "") (error ""))
	  (if (< (point) skk-henkan-start-point)
	      (error "뤬Ѵˤޤ"))
	  (save-excursion
	    (beginning-of-line)
	    (if (> (point) skk-henkan-start-point)
		(error "Henkan key may not contain a new line character.")))
	  (move-marker skk-henkan-end-point (point))
	  ;; modified by Takeshi OHTANI, 1995.1.17.
	  (setq skk-henkan-key
		(let ((key (buffer-substring skk-henkan-start-point
					     skk-henkan-end-point)))
		  (substring key 0 (string-match " " key)))
		skk-henkan-vector (vector))
	  ;;(insert " ")
	  (setq skk-search-key (skk-compute-numeric-henkan-key))
	  (skk-henkan)
	  ;;(delete-backward-char 1)
	  (if (and skk-abbrev skk-henkan-active) (use-local-map skk-map))))
    (skk-self-insert arg)))

(defun skk-set-henkan-point-subr (&optional arg)
  "ʤϤǡݥȤѴϤΥޡ \(\) դ롣
Ϥδؿ skk-set-henkan-point ؿǤ롣"
  (interactive)
  (if skk-henkan-on (skk-kakutei))
  (if (and skk-use-nicola
	   (or skk-nic-use-kana-for-henkan
	       (skk-in-minibuffer-p))) ;; ޤ褯ʤ minibuffer 
                                      ;; äȤˤʥ⡼ɤˤƤ٤
	  (skk-nic-select-hiragana))
  (insert "")
  (set-marker skk-kana-start-point (point))
  (setq skk-henkan-on t)
  (move-marker skk-henkan-start-point (point)))


(defun skk-delete-backward-char (count)
  (interactive "P")
  (if skk-okurigana
      (progn
	(setq skk-okurigana nil)
	(if (and (char-after (+ skk-okurigana-start-point 0))
		 (= (char-after (+ skk-okurigana-start-point 0)) ?*))
	    (delete-region skk-okurigana-start-point
			   (1+ skk-okurigana-start-point)))))
  (if (and skk-henkan-on (= (point) skk-henkan-start-point))
      (progn
	(setq skk-henkan-count 0)
	(skk-kakutei))
    (if skk-henkan-active 
	(let ((p (+ skk-henkan-end-point 0)))
	  (if (and (not skk-delete-implies-kakutei) (= p (point)))
	      (skk-previous-candidate)
           (delete-backward-char (prefix-numeric-value count) count)
           (if (< (point) p) (skk-kakutei))))
      (if (skk-in-minibuffer-p)
	  (delete-backward-char (prefix-numeric-value count))
	;; small emulation routine. Is it usefull?
	(let ((local-map (current-local-map)))
	  (unwind-protect
	      (progn
		(use-local-map skk-emacs-local-map)
		(command-execute (or (key-binding "\177")
				     (function undefined)))
		(use-local-map local-map)))) ))))
;	(skk-emulate-original-map count)))))

(provide 'skk-nicola)
