;; skk-roma.el
;; skk.el ޻ϴϢδؿȴФΡ
;; skk-nicola 

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either versions 2, or (at your option)
;; any later version.

;; This program is distributed in the hope that it will be useful
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with SKK, see the file COPYING.  If not, write to the Free
;; Software Foundation Inc., 59 Temple Place - Suite 330, Boston,
;; MA 02111-1307, USA.

(setq skk-previous-candidate-char ?x)

(setq skk-mode-string "R-SKK:")
(setq skk-hirakana-mode-string "R-")
(setq skk-katakana-mode-string "R-")
;(setq skk-zenei-mode-string "--")

(defconst skk-kana-rom-vector
  ["x" "a" "x" "i" "x" "u" "x" "e" "x" "o" "k" "g" "k" "g" "k" "g"
   "k" "g" "k" "g" "s" "z" "s" "j" "s" "z" "s" "z" "s" "z" "t" "d"
   "t" "d" "x" "t" "d" "t" "d" "t" "d" "n" "n" "n" "n" "n" "h" "b"
   "p" "h" "b" "p" "h" "b" "p" "h" "b" "p" "h" "b" "p" "m" "m" "m"
   "m" "m" "x" "y" "x" "y" "x" "y" "r" "r" "r" "r" "r" "x" "w" "x"
   "x" "w" "n"]
  "*kana to roman conversion giving only the first roman character
corresponding to the following kana characters.  For the characters
֤, ֤,֤ա, you might want to change the values for them to
\"z\", \"c\", \"f\".
                                  
                                  
                                  
                                  
                                  
        ")

(defconst skk-roma-kana-a
  '(("" . ("" . ""))
    ("b" . ("" . "")) ("by" . ("Ӥ" . "ӥ"))
    ("ch" . ("" . "")) ("cy" . ("" . "")) 
    ("d" . ("" . "")) ("dh" . ("Ǥ" . "ǥ"))
    ("dy" . ("¤" . "¥"))
    ("f" . ("դ" . "ե")) ("fy" . ("դ" . "ե"))
    ("g" . ("" . "")) ("gy" . ("" . ""))
    ("h" . ("" . "")) ("hy" . ("Ҥ" . "ҥ"))
    ("j" . ("" . "")) ("jy" . ("" . ""))
    ("k" . ("" . "")) ("ky" . ("" . ""))
    ("m" . ("" . "")) ("my" . ("ߤ" . "ߥ"))
    ("n" . ("" . "")) ("ny" . ("ˤ" . "˥"))
    ("p" . ("" . "")) ("py" . ("Ԥ" . "ԥ"))
    ("r" . ("" . "")) ("ry" . ("" . ""))
    ("s" . ("" . "")) ("sh" . ("" . ""))
    ("sy" . ("" . ""))
    ("t" . ("" . "")) ("th" . ("Ƥ" . "ƥ"))
    ("ty" . ("" . ""))
    ("v" . ("" . "")) ("w" . ("" . ""))
    ("x" . ("" . "")) ("xk" . ("" . ""))
    ("xw" . ("" . "")) ("xy" . ("" . ""))
    ("y" . ("" . ""))
    ("z" . ("" . "")) ("zy" . ("" . ""))))

(defconst skk-roma-kana-i
  '(("" . ("" . ""))
    ("b" . ("" . "")) ("by" . ("Ӥ" . "ӥ"))
    ("ch" . ("" . "")) ("cy" . ("" . ""))
    ("d" . ("" . "")) ("dh" . ("Ǥ" . "ǥ"))
    ("dy" . ("¤" . "¥"))
    ("f" . ("դ" . "ե")) ("fy" . ("դ" . "ե"))
    ("g" . ("" . "")) ("gy" . ("" . ""))
    ("h" . ("" . "")) ("hy" . ("Ҥ" . "ҥ"))
    ("j" . ("" . "")) ("jy" . ("" . ""))
    ("k" . ("" . "")) ("ky" . ("" . ""))
    ("m" . ("" . "")) ("my" . ("ߤ" . "ߥ"))
    ("n" . ("" . "")) ("ny" . ("ˤ" . "˥"))
    ("p" . ("" . "")) ("py" . ("Ԥ" . "ԥ"))
    ("r" . ("" . "")) ("ry" . ("ꤣ" . "ꥣ"))
    ("s" . ("" . "")) ("sh" . ("" . ""))
    ("sy" . ("" . ""))
    ("t" . ("" . "")) ("th" . ("Ƥ" . "ƥ"))
    ("ty" . ("" . ""))
    ("v" . ("" . "")) ("w" . ("" . ""))
    ("x" . ("" . "")) ("xw" . ("" . ""))
    ("z" . ("" . "")) ("zy" . ("" . ""))))

(defconst skk-roma-kana-u
  '(("" . ("" . ""))
    ("b" . ("" . "")) ("by" . ("Ӥ" . "ӥ"))
    ("ch" . ("" . "")) ("cy" . ("" . ""))
    ("d" . ("" . "")) ("dh" . ("Ǥ" . "ǥ"))
    ("dy" . ("¤" . "¥"))
    ("f" . ("" . "")) ("fy" . ("դ" . "ե"))
    ("g" . ("" . "")) ("gy" . ("" . ""))
    ("h" . ("" . "")) ("hy" . ("Ҥ" . "ҥ"))
    ("j" . ("" . "")) ("jy" . ("" . ""))
    ("k" . ("" . "")) ("ky" . ("" . ""))
    ("m" . ("" . "")) ("my" . ("ߤ" . "ߥ"))
    ("n" . ("" . "")) ("ny" . ("ˤ" . "˥"))
    ("p" . ("" . "")) ("py" . ("Ԥ" . "ԥ"))
    ("r" . ("" . "")) ("ry" . ("" . ""))
    ("s" . ("" . "")) ("sh" . ("" . ""))
    ("sy" . ("" . ""))
    ("t" . ("" . "")) ("th" . ("Ƥ" . "ƥ"))
    ("ts" . ("" . "")) ("ty" . ("" . ""))
    ("v" . ("" . "")) ("w" . ("" . ""))
    ("x" . ("" . "")) ("xt" . ("" . ""))
    ("xts" . ("" . "")) ("xy" . ("" . ""))
    ("y" . ("" . ""))
    ("z" . ("" . "")) ("zy" . ("" . ""))))

(defconst skk-roma-kana-e
  '(("" . ("" . ""))
    ("b" . ("" . "")) ("by" . ("Ӥ" . "ӥ"))
    ("ch" . ("" . "")) ("cy" . ("" . ""))
    ("d" . ("" . "")) ("dh" . ("Ǥ" . "ǥ"))
    ("dy" . ("¤" . "¥"))
    ("f" . ("դ" . "ե")) ("fy" . ("դ" . "ե"))
    ("g" . ("" . "")) ("gy" . ("" . ""))
    ("h" . ("" . "")) ("hy" . ("Ҥ" . "ҥ"))
    ("j" . ("" . "")) ("jy" . ("" . ""))
    ("k" . ("" . "")) ("ky" . ("" . ""))
    ("m" . ("" . "")) ("my" . ("ߤ" . "ߥ"))
    ("n" . ("" . "")) ("ny" . ("ˤ" . "˥"))
    ("p" . ("" . "")) ("py" . ("Ԥ" . "ԥ"))
    ("r" . ("" . "")) ("ry" . ("ꤧ" . "ꥧ"))
    ("s" . ("" . "")) ("sh" . ("" . ""))
    ("sy" . ("" . ""))
    ("t" . ("" . "")) ("th" . ("Ƥ" . "ƥ"))
    ("ty" . ("" . ""))
    ("v" . ("" . "")) ("w" . ("" . ""))
    ("x" . ("" . "")) ("xk" . ("" . ""))
    ("xw" . ("" . ""))
    ("y" . ("" . ""))
    ("z" . ("" . "")) ("zy" . ("" . ""))))

(defconst skk-roma-kana-o
  '(("" . ("" . ""))
    ("b" . ("" . "")) ("by" . ("Ӥ" . "ӥ"))
    ("ch" . ("" . "")) ("cy" . ("" . ""))
    ("d" . ("" . "")) ("dh" . ("Ǥ" . "ǥ"))
    ("dy" . ("¤" . "¥"))
    ("f" . ("դ" . "ե")) ("fy" . ("դ" . "ե"))
    ("g" . ("" . "")) ("gy" . ("" . ""))
    ("h" . ("" . "")) ("hy" . ("Ҥ" . "ҥ"))
    ("j" . ("" . "")) ("jy" . ("" . ""))
    ("k" . ("" . "")) ("ky" . ("" . ""))
    ("m" . ("" . "")) ("my" . ("ߤ" . "ߥ"))
    ("n" . ("" . "")) ("ny" . ("ˤ" . "˥"))
    ("p" . ("" . "")) ("py" . ("Ԥ" . "ԥ"))
    ("r" . ("" . "")) ("ry" . ("" . ""))
    ("s" . ("" . "")) ("sh" . ("" . ""))
    ("sy" . ("" . ""))
    ("t" . ("" . "")) ("th" . ("Ƥ" . "ƥ"))
    ("ty" . ("" . ""))
    ("v" . ("" . "")) ("w" . ("" . ""))
    ("x" . ("" . "")) ("xy" . ("" . ""))
    ("y" . ("" . ""))
    ("z" . ("" . "")) ("zy" . ("" . ""))))

(load skk-init-file t)

(defun skk-insert-a ()
  (interactive)
  (skk-insert skk-roma-kana-a))

(defun skk-insert-i ()
  (interactive)
  (skk-insert skk-roma-kana-i))

(defun skk-insert-u ()
  (interactive)
  (skk-insert skk-roma-kana-u))

(defun skk-insert-e ()
  (interactive)
  (skk-insert skk-roma-kana-e))

(defun skk-insert-o ()
  (skk-insert skk-roma-kana-o))


;; Hisao Kuroda suggested to make the argument of the following function
;; to be an optional argument, 1993.6.1.

(defun skk-set-henkan-point (&optional arg)
  (interactive "P")
  (let* ((normal (and (<= ?A last-command-char) (<= last-command-char ?Z)))
	 (last-char (if normal (+ 32 last-command-char) last-command-char))
	 (sokuon (and (string= skk-prefix (char-to-string last-char))
		      (/= last-char ?o)))
	 (henkan-active skk-henkan-active))
    (if (or (not skk-henkan-on) skk-henkan-active)
	(if normal
	    (skk-set-henkan-point-subr)
	  (if skk-henkan-on
	      (skk-set-henkan-point-subr))
	  ;; modified by Kazuo Hirokawa, 1993.6.3.
	  (if henkan-active
	      (skk-emulate-original-map arg)
	    (skk-self-insert arg)))
      (if normal
	  ;; prepare for the processing of okurigana if not skk-okurigana and
	  ;; the preceding character is not a numeric character.
	  ;; if the previous char is a special midashi char or a
	  ;; numeric character, we assume that the user intended to type the
	  ;; last-command-char in lower case.
	  (if (and (not skk-okurigana)
		   (not
		    (and (not (= skk-henkan-start-point (point)))
			 (let ((p1 (char-after (1- (point))))
			       (p2 (char-after (- (point) 2))))
			   (or
			    ;; previous char is a special midashi char
			    (memq p1 skk-special-midashi-char-list)
			    ;; previous char is an ascii numeric char
			    (and (<= ?0 p1) (<= p1 ?9))
			    ;; previous char is a jis numeric char
			    (and (= p2 163) (<= 176 p1) (<= p1 185)))))))
	      (if skk-process-okuri-early
		  (progn
		    (move-marker skk-henkan-end-point (point))
		    (setq skk-henkan-key
			  (concat (buffer-substring skk-henkan-start-point
						    (if sokuon
							skk-kana-start-point
						      (point)))
				  (if sokuon
				      (if skk-katakana "" "")
				    "")
				  (char-to-string last-char)))
		    (if sokuon (skk-erase-prefix))
		    (insert (if sokuon
				(if skk-katakana "" "")
			      "")
			    " ")
		    (setq skk-prefix "")
		    (skk-henkan)
		    (delete-backward-char (if sokuon 2 1))
		    ;; we set skk-kana-start-point here, since the marker may
		    ;; no longer point at the correct position after skk-henkan.
		    (set-marker skk-kana-start-point (point)))
		;; modified by Wataru Matsui, 1991.8.16
		(if (= skk-henkan-start-point (point))
		    nil
		  (if sokuon
		      (progn
			(skk-erase-prefix)
			(insert (if skk-katakana "" ""))
			(setq skk-prefix "")))
		  (move-marker skk-okurigana-start-point (point))
		  (insert "*")
		  (set-marker skk-kana-start-point (point))
		  (setq skk-okuri-char (char-to-string last-char))
		  (setq skk-okurigana t))))
	;; process special char
	(insert last-char)
	(move-marker skk-henkan-end-point (point))
	(setq skk-henkan-key (buffer-substring skk-henkan-start-point (point)))
	(setq skk-search-key skk-henkan-key)
	(setq skk-prefix "")
	;;(insert " ")
	(skk-henkan)
	;;(delete-backward-char 1)
	))
    (if normal (setq unread-command-char last-char))))


(defun skk-set-okurigana ()
  (let (w-head)
    (move-marker skk-henkan-end-point skk-okurigana-start-point)
    (save-excursion
      ;; just in case
      (goto-char skk-okurigana-start-point)
      (or (looking-at "*") (insert "*")))
    (setq w-head (buffer-substring
		  skk-henkan-start-point
		  skk-henkan-end-point))
    (setq skk-henkan-key2
	  (concat w-head
		  "*"
		  (setq skk-henkan-okurigana
			(buffer-substring
			 (1+ skk-okurigana-start-point)
			 (point)))))
;  t //[ä//]/ -> t //[//]/  ˤѥå (3)
    (if (> (length skk-henkan-okurigana) skk-kanji-len)
	(setq skk-henkan-okurigana
	      (substring skk-henkan-okurigana 0 skk-kanji-len)))
;; ꤬ wiueo -> w ǰѥå (7)
;    (if (and skk-nic-incompat-jisyo
;	     (or (string= skk-okuri-char "i")
;		 (string= skk-okuri-char "u")
;		 (string= skk-okuri-char "e")
;		 (string= skk-okuri-char "o")))
;	(setq skk-henkan-key (concat w-head "w"))
;      (setq skk-henkan-key (concat w-head skk-okuri-char)))
    (setq skk-henkan-key (concat w-head skk-okuri-char))
    (setq skk-prefix ""
	  skk-okuri-char "")
    (delete-region
     skk-okurigana-start-point (1+ skk-okurigana-start-point))
    (skk-henkan)
    (setq skk-okurigana nil)))

(defun skk-start-henkan (arg)
  (interactive "p")
  (if skk-henkan-on
      (progn
	(setq skk-j-mode t)
	(if skk-henkan-active (skk-henkan)
	  (or (string= skk-prefix "") (error ""))
	  (if (< (point) skk-henkan-start-point)
	      (error "Henkan end point must be after henkan start point."))
	  (save-excursion
	    (beginning-of-line)
	    (if (> (point) skk-henkan-start-point)
		(error "Henkan key may not contain a new line character.")))
	  (move-marker skk-henkan-end-point (point))
	  ;; modified by Takeshi OHTANI, 1995.1.17.
	  (setq skk-henkan-key
		(let ((key (buffer-substring skk-henkan-start-point
					     skk-henkan-end-point)))
		  (substring key 0 (string-match " " key)))
		skk-henkan-vector (vector))
	  ;;(insert " ")
	  (setq skk-search-key (skk-compute-numeric-henkan-key))
	  (skk-henkan)
	  ;;(delete-backward-char 1)
	  (if (and skk-abbrev skk-henkan-active) (use-local-map skk-map))))
    (skk-self-insert arg)))


;; other inserting functions

(defun skk-insert-comma (count)
  (interactive "p")
  (if (eq last-command 'skk-completion)
      (skk-previous-completion)
    (skk-self-insert count)))

(defun skk-insert-period (count)
  (interactive "p")
  (if (eq last-command 'skk-completion)
      (progn
	(setq this-command 'skk-completion)
	(skk-completion nil))
    (skk-self-insert count)))

(defun skk-define-map (map &optional minibuff)
  "Setup skk key bindings for the keymap MAP.  If the optional argument
MINIBUFF is t, the map is used in the minibuffer."
  (define-key map "\C-g" 'skk-keyboard-quit)
  (define-key map
    (if minibuff (default-value 'skk-kakutei-key) skk-kakutei-key)
    'skk-kakutei)
  (define-key map "\C-m" 'skk-newline)
  (define-key map "\t" 'skk-try-completion)
  (define-key map "\ " 'skk-start-henkan)
  (define-key map "!" 'skk-self-insert)
  (define-key map "\"" 'skk-self-insert)
  (define-key map "#" 'skk-self-insert)
  (define-key map "$" 'skk-display-code-for-char-at-point)
  (define-key map "%" 'skk-self-insert)
  (define-key map "&" 'skk-self-insert)
  (define-key map "'" 'skk-self-insert)
  (define-key map "\(" 'skk-self-insert)
  (define-key map "\)" 'skk-self-insert)
  (define-key map "*" 'skk-self-insert)
  (define-key map "+" 'skk-self-insert)
  (define-key map "," 'skk-insert-comma)
  (define-key map "-" 'skk-self-insert)
  (define-key map "." 'skk-insert-period)
  (define-key map "/" 'skk-abbrev-input)
  (define-key map "0" 'skk-self-insert)
  (define-key map "1" 'skk-self-insert)
  (define-key map "2" 'skk-self-insert)
  (define-key map "3" 'skk-self-insert)
  (define-key map "4" 'skk-self-insert)
  (define-key map "5" 'skk-self-insert)
  (define-key map "6" 'skk-self-insert)
  (define-key map "7" 'skk-self-insert)
  (define-key map "8" 'skk-self-insert)
  (define-key map "9" 'skk-self-insert)
  (define-key map ":" 'skk-self-insert)
  (define-key map ";" 'skk-self-insert)
  (define-key map "<" 'skk-set-henkan-point)
  (define-key map "=" 'skk-self-insert)
  (define-key map ">" 'skk-set-henkan-point)
  (define-key map "?" 'skk-set-henkan-point)
  (define-key map "@" 'skk-today)
  (define-key map "A" 'skk-set-henkan-point)
  (define-key map "B" 'skk-set-henkan-point)
  (define-key map "C" 'skk-set-henkan-point)
  (define-key map "D" 'skk-set-henkan-point)
  (define-key map "E" 'skk-set-henkan-point)
  (define-key map "F" 'skk-set-henkan-point)
  (define-key map "G" 'skk-set-henkan-point)
  (define-key map "H" 'skk-set-henkan-point)
  (define-key map "I" 'skk-set-henkan-point)
  (define-key map "J" 'skk-set-henkan-point)
  (define-key map "K" 'skk-set-henkan-point)
  (define-key map "L" 'skk-zenkaku-eiji)
  (define-key map "M" 'skk-set-henkan-point)
  (define-key map "N" 'skk-set-henkan-point)
  (define-key map "O" 'skk-set-henkan-point)
  (define-key map "P" 'skk-set-henkan-point)
  (define-key map "Q" 'skk-set-henkan-point-subr)
  (define-key map "R" 'skk-set-henkan-point)
  (define-key map "S" 'skk-set-henkan-point)
  (define-key map "T" 'skk-set-henkan-point)
  (define-key map "U" 'skk-set-henkan-point)
  (define-key map "V" 'skk-set-henkan-point)
  (define-key map "W" 'skk-set-henkan-point)
  (define-key map "X" 'skk-purge-from-jisyo)
  (define-key map "Y" 'skk-set-henkan-point)
  (define-key map "Z" 'skk-set-henkan-point)
  (define-key map "\[" 'skk-self-insert) 
  (define-key map "\\" 'skk-input-by-code-or-menu)
  (define-key map "\]" 'skk-self-insert)
  (define-key map "^" 'skk-self-insert)
  (define-key map "_" 'skk-self-insert)
  (define-key map "`" 'skk-self-insert)
  (define-key map "a" 'skk-insert-a)
  (define-key map "b" 'skk-kana-input)
  (define-key map "c" 'skk-kana-input)
  (define-key map "d" 'skk-kana-input)
  (define-key map "e" 'skk-insert-e)
  (define-key map "f" 'skk-kana-input)
  (define-key map "g" 'skk-kana-input)
  (define-key map "h" 'skk-kana-input)
  (define-key map "i" 'skk-insert-i)
  (define-key map "j" 'skk-kana-input)
  (define-key map "k" 'skk-kana-input)
  (define-key map "l" (if minibuff 'skk-mode-off-in-minibuff 'skk-mode-off))
  (define-key map "m" 'skk-kana-input)
  (define-key map "n" 'skk-kana-input)
  (define-key map "o" 'skk-kana-input)
  (define-key map "p" 'skk-kana-input)
  (define-key map "q" 'skk-toggle-kana)
  (define-key map "r" 'skk-kana-input)
  (define-key map "s" 'skk-kana-input)
  (define-key map "t" 'skk-kana-input)
  (define-key map "u" 'skk-insert-u)
  (define-key map "v" 'skk-kana-input)
  (define-key map "w" 'skk-kana-input)
  (define-key map "x" 'skk-previous-candidate)
  (define-key map "y" 'skk-kana-input)
  (define-key map "z" 'skk-kana-input)
  (define-key map "\{" 'skk-self-insert)
  (define-key map "|" 'skk-self-insert)
  (define-key map "\}" 'skk-self-insert)
  (define-key map "~" 'skk-self-insert)
  (define-key map "\177" 'skk-delete-backward-char)
  ;;(define-key map "\M-k" 'j-katakana-henkan)
  ;;(define-key map "\M-h" 'j-hiragana-henkan)
  ;;(define-key map "\M-z" 'j-zenkaku-henkan)
  )


(defun skk-setup-abbrev-map ()
  (setq skk-abbrev-map (skk-convert-to-vector skk-emacs-local-map))
  (define-key skk-abbrev-map "\C-g" 'skk-keyboard-quit)
  (define-key skk-abbrev-map skk-kakutei-key 'skk-kakutei)
  (define-key skk-abbrev-map "\t" 'skk-try-completion)
  (define-key skk-abbrev-map "\C-m" 'skk-newline)
  (define-key skk-abbrev-map "\C-q" 'skk-zenkaku-henkan)
  (define-key skk-abbrev-map "." 'skk-abbrev-period)
  (define-key skk-abbrev-map "," 'skk-abbrev-comma)
  (define-key skk-abbrev-map "\ " 'skk-start-henkan)
  (define-key skk-abbrev-map "\177" 'skk-delete-backward-char)
  ;;(define-key skk-abbrev-map "\M-z" 'skk-zenkaku-henkan)
  )

;; kana inserting functions

(defun skk-insert (table)
  (let ((char (assoc skk-prefix table)) str)
    (if (null char)
	;; skk-prefix not found in the table
	(setq skk-prefix ""
	      unread-command-char last-command-char)
      (if (and (and skk-kakutei-early (not skk-process-okuri-early))
	       skk-henkan-active) (skk-kakutei))
      (setq str (if skk-katakana (cdr (cdr char)) (car (cdr char))))
      (skk-insert-str str)
      (if skk-okurigana
	  (skk-set-okurigana)
	(setq skk-prefix ""))
      ;; Modified at the suggestion of Kazuo Hirokawa, 1992.3.9.
      ;; modified by Tsugutomo Enami, 1994.7.9.
      (if (not skk-henkan-on) (skk-do-auto-fill)))))

;; kana input by romaji to kana conversion

(defun skk-kana-input ()
  "Start romaji-to-kana conversion.  The character `o' calls this function in
order to treat `ohta' etc."
  (interactive)
  (if (and (and skk-kakutei-early (not skk-process-okuri-early))
	   skk-henkan-active) (skk-kakutei))
  (let ((char (char-to-string last-command-char))
	;; don't echo key strokes in the minibuffer
	(echo-keystrokes 0)
	(cont t))
    (if skk-isearch-message (j-isearch-message))
    ;; modified by Kiyotaka Sakai, 1993.8.19
    ;; modified by Chikanobu Toyofuku, 1993.8.23
    (if (and (= last-command-char ?o)
	     (null (skk-assoc-rule (concat skk-prefix char))))
	(progn
	  (skk-insert-o)
	  (if skk-isearch-message
	      (progn
		(j-isearch-message)
		(setq cont nil)
		;; thus you must type `oota' instead of `ohta' when inputting
		;; isearch string
		)
	    (setq skk-prefix char)
	    (set-marker skk-kana-start-point (point))))
      (setq skk-prefix char)
      (set-marker skk-kana-start-point (point))
      (skk-insert-prefix))
    (condition-case conditions
	(while cont
	  ;; modified by Kiyotaka Sakai, 1994.11.8.
	  (let* ((r-char (skk-read-char))
		 (r-char (if (= r-char ?\C-g)
			     (signal 'quit nil)
			   (if (and skk-henkan-on
				    (not skk-henkan-active)
				    ;; we must distinguish the two cases where
				    ;; SKK-ECHO is on and off
				    (= skk-henkan-start-point
				       (if skk-echo (1- (point)) (point)))
				    (< 64 r-char) (< r-char 91))
			       ;; this case takes care of the rare case where
			       ;; one types two characters in upper case
			       ;; consequtively.  For example, one sometimes
			       ;; types "TE" when one should type "Te"
			       (+ 32 r-char)
			     r-char)))
		 (input (char-to-string r-char))
		 (prefix (concat skk-prefix input))
		 (next (skk-assoc-rule prefix)))
	    (if skk-isearch-message (j-isearch-message))
	    (cond (next
		   (let ((newprefix (car next))
			 (output (car (cdr next))))
		     (skk-erase-prefix)
		     (if output
			 (progn
			   (skk-insert-str
			    (if skk-katakana (car output) (cdr output)))
			   (if skk-okurigana (skk-set-okurigana))))
		     (if newprefix
			 (progn
			   (set-marker skk-kana-start-point (point))
			   ;; modified by Naoki HAMADA, 1993.7.4.
			   (skk-insert-prefix newprefix)
			   (setq skk-prefix newprefix))
		       (setq cont nil)
		       (setq skk-prefix ""))))
		  ((string= skk-prefix "n")
		   (cond ((= (aref skk-char-type-vector r-char) 3) ;; vowel
			  (skk-erase-prefix)
			  (setq cont nil)
			  (setq unread-command-char r-char))
			 ((= r-char ?y)
			  (setq skk-prefix prefix)
			  (skk-insert-prefix ?y))
			 ((and skk-okurigana (= r-char 32))
			  (setq unread-command-char ?n))
			 (t
			  (skk-erase-prefix)
			  (skk-insert-str (if skk-katakana "" ""))
			  (set-marker skk-kana-start-point (point))
			  (setq skk-prefix "")
			  (setq cont nil)
			  (setq unread-command-char r-char))))
		  ((string= skk-prefix "o")
		   (if (= r-char ?h)
		       (progn
			 (setq skk-prefix prefix)
			 (skk-insert-prefix "h"))
		     ;; the following line was added
		     ;; by Chikanobu Toyofuku, 1993.8.23
		     (skk-erase-prefix)
		     (setq cont nil
			   skk-prefix ""
			   unread-command-char r-char)))
		  ((string= skk-prefix "oh")
		   (if (= (aref skk-char-type-vector r-char) 3)
		       ;; vowel
		       (progn
			 (setq cont nil)
			 (skk-erase-prefix)
			 (setq skk-prefix "h")
			 (setq unread-command-char r-char))
		     (skk-erase-prefix)
		     (skk-insert-str (if skk-katakana "" ""))
		     (setq cont nil
			   skk-prefix ""
			   unread-command-char r-char)))
		  ((and (string= input skk-prefix)
			(= (aref skk-char-type-vector r-char) 1))
		   (skk-erase-prefix)
		   (skk-insert-str (if skk-katakana "" ""))
		   (set-marker skk-kana-start-point (point))
		   (skk-insert-prefix r-char))
		  ((skk-member prefix skk-prefix-list)
		   (setq skk-prefix prefix)
		   (skk-insert-prefix input))
		  ((= (aref skk-char-type-vector r-char) 3) ;; vowel
		   (setq cont nil)
		   (skk-erase-prefix)
		   (setq unread-command-char r-char))
		  ((= (aref skk-char-type-vector r-char) 4)
		   ;; j-set-henkan-point
		   (let ((last-command-char r-char))
		     (skk-erase-prefix)
		     (skk-set-henkan-point)))
		  ((= (aref skk-char-type-vector r-char) 5) ;; delete prefix
		   (setq cont nil)
		   (if (and skk-okurigana
			    (= (char-after (+ skk-okurigana-start-point 0)) ?*))
		       (progn
			 (delete-region skk-okurigana-start-point
					(1+ skk-okurigana-start-point))
			 (set-marker skk-kana-start-point
				     (+ skk-okurigana-start-point 0))
			 (setq skk-okurigana nil)))
		   (or (string= skk-prefix "")
		       (if skk-echo
			   (skk-erase-prefix)
			 (message "Deleted prefix \"%s\"." skk-prefix)))
		   (setq skk-prefix ""))
		  (t
		   (setq cont nil)
		   (skk-erase-prefix)
		   (set-marker skk-kana-start-point nil)
		   (setq skk-prefix "")
		   (setq unread-command-char r-char)))))
      (quit
       (if (string= skk-prefix "o")
	   ;; moified by Kazuo Hirokawa, 1992.7.10.
	   (skk-keyboard-quit)
	 (setq skk-prefix "")
	 (skk-erase-prefix)
	 (set-marker skk-kana-start-point nil)
	 (ding))))))

;; convert skk-rom-kana-rule-list to skk-rom-kana-rule-tree.
;; The rule tree follows the following syntax:
;; <tree> ::= ((<char> . <tree>) . <tree>) | nil
;; <item> ::= (<char> . <tree>)

(defun j-compile-rule-list (l)
  "compile rom-kana-rule-list into a tree form."
  (let ((tree nil))
    (while l
      (setq rule (car l))
      (setq l (cdr l))
      (setq tree (skk-add-rule rule tree)))
    tree))

(defun skk-add-rule (rule tree)
  "destructivley add RULE to TREE."
  (let* ((str (car rule))
	 (char (string-to-char str))
	 (rest (substring str 1))
	 (rule-body (cdr rule))
	 (root tree))
    (skk-add-rule-main char rest rule-body tree)
    root))

(defun skk-add-rule-main (char rest body tree)
  (let ((item (skk-search-tree char tree)) (cont t))
    (if item
	(if (string= rest "")
	    (setcdr item (cons (cons 0 body) (cdr item)))
	  (skk-add-rule-main
	   (string-to-char rest) (substring rest 1) body (cdr item)))
      ;; key not found, so add rule to the end of the tree
      (if (null root)
	  (setq root (skk-make-rule-tree char rest body))
	(while (and cont tree)
	  (if (null (cdr tree))
	      (progn
		(setcdr tree (skk-make-rule-tree char rest body))
		(setq cont nil))
	    (setq tree (cdr tree))))))))

(defun skk-make-rule-tree (char rest body)
  (if (string= rest "")
      (list (cons char (list (cons 0 body))))
    (list
     (cons char
	   (skk-make-rule-tree
	    (string-to-char rest) (substring rest 1) body)))))

(defun skk-search-tree (char tree)
  (let ((cont t) (v nil))
    (while (and cont tree)
      (if (= char (car (car tree)))
	  (setq v (car tree)
		cont nil)
	(setq tree (cdr tree))))
    v))

(defun skk-assoc-rule (key)
  (if skk-rom-kana-rule-tree
      (skk-assoc-tree key skk-rom-kana-rule-tree)
    (skk-assoc key skk-rom-kana-rule-list)))

(defun skk-assoc-tree (key tree)
  (let ((char (string-to-char key)) (rest (substring key 1))
	(cont t) (v nil))
    (while (and tree cont)
      (if (= char (car (car tree)))
	  (if (string= rest "")
	      (setq v (if (= 0 (car (car (cdr (car tree)))))
			  (cdr (car (cdr (car tree)))))
		    cont nil)
	    (setq v (skk-assoc-tree rest (cdr (car tree)))
		  cont nil))
	(setq tree (cdr tree))))
    v))

(defun skk-set-henkan-point-subr ()
  (interactive)
  (if skk-henkan-on (skk-kakutei))
  (or (string= skk-prefix "") (skk-erase-prefix))
  (insert "")
  (or (string= skk-prefix "")
      (progn
	(set-marker skk-kana-start-point (point))
	(insert skk-prefix)))
  (setq skk-henkan-on t)
  (move-marker skk-henkan-start-point (point)))

